JRE="JRE-19.0.1"

Set fs = WScript.CreateObject("Scripting.FileSystemObject")
Set WshShell = WScript.CreateObject("WScript.Shell")
Set fso=CreateObject("Scripting.FileSystemObject")

Title="Install/Update TRAD"
Message0="Please first terminate TRAD (javaw.exe)"
Message1="Install Directory"
Message2="Install/Update Successful."
Message3="fixed-width-font install failed, check internet access"
Message4="JRE install failed, check internet access"
Message5="Download and Unzip fixed-width-font"
Message6="Download and Unzip local JRE"
WaitMessage="Please Wait"

Locale=getLocale()
If Locale=1041 Then 
   Title="TRAD ̃CXg[EAbvf[g"
   Message0="܂ TRAD (javaw.exe) IĂ"
   Message1="CXg[̎w"
   Message2="CXg["
   Message3="fixed-width-font ̃CXg[ɎsCC^[lbgANZX𒲂ׂĂ"
   Message4="JRE ̃CXg[ɎsCC^[lbgANZX𒲂ׂĂ"
   Message5="fixed-width-font _E[h"
   Message6="TRADp JRE _E[h"
   WaitMessage="҂"
End If

'check if TRAD is running 
 temp=WshShell.ExpandEnvironmentStrings("%TEMP%\out.txt")
 WshShell.RUN "cmd /c tasklist.exe > " & temp, 0, True
  strOutput = fso.OpenTextFile(temp).ReadAll()
  fso.DeleteFile temp
   RtnCode=InStr(StrOutput, "javaw.exe")
    If not RtnCode = 0 Then
       MsgBox Message0
       WScript.Quit
    End If


' set default install directory
HomeDir=WshShell.expandEnvironmentStrings("%HOMEDRIVE%%HOMEPATH%\")
InstallDir=HomeDir & "TRAD.public"

' set current directory
scriptPath = WScript.ScriptFullName
scriptPath = left(scriptPath,len(scriptPath)-len(WScript.ScriptName))
scriptDir=Left(scriptPath, Len(scriptPath)-1)
WshShell.CurrentDirectory=scriptDir

' ask install directory
InstallDir=InputBox( Message1,Title, InstallDir )
If InstallDir="" Then WScript.Quit

' copy
logfile=ScriptPath & "log.txt"
cmd="ROBOCOPY " &  """" & ScriptDir & """" & " " & """" & InstallDir & """" & " /PURGE /R:0 /XX /MIR /MT /XF log.txt install.vbs /LOG:" & """" & logfile & """"
r=WshShell.Run (cmd , 0, TRUE )
If r >7 Then 
	MsgBox "RoboCopy error=" & r & ", exit now"
	Wscript.Quit
End If

' set  .TRADhistory attribute
cmd="attrib -h -a "+InstallDir+"\conf\.TRADhistory"
r=WshShell.Run(cmd, 0, TRUE)
If r >7 Then 
	MsgBox ".TRADhistory attribute change error=" & r & ", exit now"
	Wscript.Quit
End If


' install fixed-width-font if not
If not fs.FolderExists(InstallDir & "\fixed-width-font") Then
  r=0
  r=WshShell.Popup(WaitMessage, 2, Message5)
  If r=1 or r=-1 Then
    call download( "datascience.jp/TRAD/Download", "fixed-width-font.zip", InstallDir)   
  End If
End If


' install local JRE if not
If not fs.FolderExists(InstallDir & "\" & JRE) Then
   If myExists(fs.GetFolder(InstallDir), "JRE") Then
      fs.DeleteFolder(InstallDir & "\JRE*")
   End If
  r=0
  r=WshShell.Popup(WaitMessage, 2, Message6)
  If r=1 or r=-1 Then
    call download("datascience.jp/TRAD/Download/Windows", JRE+".zip", InstallDir)
  End If
End If


'create a shortcut
TargetPath = InstallDir & "\TRAD.exe" 
DesktopPath = WshShell.SpecialFolders("Desktop")
link = DesktopPath + "\TRAD.lnk"
Set shortCut = WshShell.CreateShortcut(link)
shortCut.TargetPath = TargetPath
shortCut.Save


' set DandD icon
Classes="HKCU\SOFTWARE\Classes\" 
WshShell.RegWrite Classes & ".dad\", "DandDInstance", "REG_SZ"
WshShell.RegWrite Classes & "DandDInstance\DefaultIcon\", InstallDir & "\icons\DandD.ico", "REG_SZ"
WshShell.RegWrite Classes & "DandDInstance\shell\open\command\", """" & TargetPath & """ " & """" & "%1" & """"

' set TRAD icon
WshShell.RegWrite Classes & ".TRAD\", "TRAD", "REG_SZ"
WshShell.RegWrite Classes & "TRAD\DefaultIcon\", InstallDir & "\icons\TRAD.ico", "REG_SZ"

' set TRAD open
WshShell.RegWrite Classes & "TRAD\shell\open\command\", """" & TargetPath & """ " & """" & "%1" & """"
WshShell.RegWrite Classes & "Applications\TRAD.exe\shell\open\command\", """" & TargetPath & """ " & """" & "%1" & """" 


'check install
exist1= fs.FolderExists(InstallDir & "\fixed-width-font")
exist2= fs.FolderExists(InstallDir & "\" & JRE) 

If not exist1 Then 
   		MsgBox Message3
End If

If not exist2 Then 
   		MsgBox Message4
End If


If not exist1 or not exist2 Then

Wscript.Quit

End If 


'finish
x=MsgBox( Message2,, "TRAD")



Sub download(sourceURL, zipFileName, destinationDir)

	Set fso = CreateObject("Scripting.FileSystemObject")
	sourceFile = fso.GetAbsolutePathName(zipFileName)
	destFolder = fso.GetAbsolutePathName(destinationDir)

	' get Zip file
	dim xHttp: Set xHttp = createobject("Microsoft.XMLHTTP")
	dim bStrm: Set bStrm = createobject("Adodb.Stream")
	xHttp.Open "GET", "https://" & sourceURL & "/" & zipFileName, False
	xHttp.Send

	with bStrm
	  .type = 1 '//binary
  	  .open
  	  .write xHttp.responseBody
  	  .savetofile sourceFile, 2 '//overwrite
	end with

	'unzip and install
	Set objShell = CreateObject("Shell.Application")
	Set FilesInZip=objShell.NameSpace(sourceFile).Items()
              objShell.NameSpace(destFolder).copyHere FilesInZip, 16
              fso.DeleteFile sourceFile, True
End Sub

Function myExists( sParent, sTarget )
     Dim sf, ss
     Set sf = sParent.SubFolders
      For Each ss in sf
      If Left( ss.Name, len(sTarget)) = sTarget Then
	myExists = True
	Exit Function
	End If
	Next
	myEXists = False
End Function


















'' SIG '' Begin signature block
'' SIG '' MIIqZQYJKoZIhvcNAQcCoIIqVjCCKlICAQExCzAJBgUr
'' SIG '' DgMCGgUAMGcGCisGAQQBgjcCAQSgWTBXMDIGCisGAQQB
'' SIG '' gjcCAR4wJAIBAQQQTvApFpkntU2P5azhDxfrqwIBAAIB
'' SIG '' AAIBAAIBAAIBADAhMAkGBSsOAwIaBQAEFM/8NqHzbbPf
'' SIG '' l+2zChNl7sqtW/xcoIIR7jCCBW8wggRXoAMCAQICEEj8
'' SIG '' k7RgVZSNNqfJionWlBYwDQYJKoZIhvcNAQEMBQAwezEL
'' SIG '' MAkGA1UEBhMCR0IxGzAZBgNVBAgMEkdyZWF0ZXIgTWFu
'' SIG '' Y2hlc3RlcjEQMA4GA1UEBwwHU2FsZm9yZDEaMBgGA1UE
'' SIG '' CgwRQ29tb2RvIENBIExpbWl0ZWQxITAfBgNVBAMMGEFB
'' SIG '' QSBDZXJ0aWZpY2F0ZSBTZXJ2aWNlczAeFw0yMTA1MjUw
'' SIG '' MDAwMDBaFw0yODEyMzEyMzU5NTlaMFYxCzAJBgNVBAYT
'' SIG '' AkdCMRgwFgYDVQQKEw9TZWN0aWdvIExpbWl0ZWQxLTAr
'' SIG '' BgNVBAMTJFNlY3RpZ28gUHVibGljIENvZGUgU2lnbmlu
'' SIG '' ZyBSb290IFI0NjCCAiIwDQYJKoZIhvcNAQEBBQADggIP
'' SIG '' ADCCAgoCggIBAI3nlBIiBCR0Lv8WIwKSirauNoWsR9Qj
'' SIG '' kSs+3H3iMaBRb6yEkeNSirXilt7Qh2MkiYr/7xKTO327
'' SIG '' toq9vQV/J5trZdOlDGmxvEk5mvFtbqrkoIMn2poNK1Dp
'' SIG '' S1uzuGQ2pH5KPalxq2Gzc7M8Cwzv2zNX5b40N+OXG139
'' SIG '' HxI9ggN25vs/ZtKUMWn6bbM0rMF6eNySUPJkx6otBKvD
'' SIG '' aurgL6en3G7X6P/aIatAv7nuDZ7G2Z6Z78beH6kMdrMn
'' SIG '' IKHWuv2A5wHS7+uCKZVwjf+7Fc/+0Q82oi5PMpB0RmtH
'' SIG '' NRN3BTNPYy64LeG/ZacEaxjYcfrMCPJtiZkQsa3bPizk
'' SIG '' qhiwxgcBdWfebeljYx42f2mJvqpFPm5aX4+hW8udMIYw
'' SIG '' 6AOzQMYNDzjNZ6hTiPq4MGX6b8fnHbGDdGk+rMRoO7Hm
'' SIG '' ZzOatgjggAVIQO72gmRGqPVzsAaV8mxln79VWxycVxrH
'' SIG '' eEZ8cKqUG4IXrIfptskOgRxA1hYXKfxcnBgr6kX1773V
'' SIG '' Z08oXgXukEx658b00Pz6zT4yRhMgNooE6reqB0acDZM6
'' SIG '' CWaZWFwpo7kMpjA4PNBGNjV8nLruw9X5Cnb6fgUbQMqS
'' SIG '' NenVetG1fwCuqZCqxX8BnBCxFvzMbhjcb2L+plCnuHu4
'' SIG '' nRU//iAMdcgiWhOVGZAA6RrVwobx447sX/TlAgMBAAGj
'' SIG '' ggESMIIBDjAfBgNVHSMEGDAWgBSgEQojPpbxB+zirynv
'' SIG '' gqV/0DCktDAdBgNVHQ4EFgQUMuuSmv81lkgvKEBCcCA2
'' SIG '' kVwXheYwDgYDVR0PAQH/BAQDAgGGMA8GA1UdEwEB/wQF
'' SIG '' MAMBAf8wEwYDVR0lBAwwCgYIKwYBBQUHAwMwGwYDVR0g
'' SIG '' BBQwEjAGBgRVHSAAMAgGBmeBDAEEATBDBgNVHR8EPDA6
'' SIG '' MDigNqA0hjJodHRwOi8vY3JsLmNvbW9kb2NhLmNvbS9B
'' SIG '' QUFDZXJ0aWZpY2F0ZVNlcnZpY2VzLmNybDA0BggrBgEF
'' SIG '' BQcBAQQoMCYwJAYIKwYBBQUHMAGGGGh0dHA6Ly9vY3Nw
'' SIG '' LmNvbW9kb2NhLmNvbTANBgkqhkiG9w0BAQwFAAOCAQEA
'' SIG '' Er+h74t0mphEuGlGtaskCgykime4OoG/RYp9UgeojR9O
'' SIG '' IYU5o2teLSCGvxC4rnk7U820+9hEvgbZXGNn1EAWh0SG
'' SIG '' cirWMhX1EoPC+eFdEUBn9kIncsUj4gI4Gkwg4tsB981G
'' SIG '' TyaifGbAUTa2iQJUx/xY+2wA7v6Ypi6VoQxTKR9v2Bmm
'' SIG '' T573rAnqXYLGi6+Ap72BSFKEMdoy7BXkpkw9bDlz1AuF
'' SIG '' OSDghRpo4adIOKnRNiV3wY0ZFsWITGZ9L2POmOhp36w8
'' SIG '' qF2dyRxbrtjzL3TPuH7214OdEZZimq5FE9p/3Ef738NS
'' SIG '' n+YGVemdjPI6YlG87CQPKdRYgITkRXta2DCCBhowggQC
'' SIG '' oAMCAQICEGIdbQxSAZ47kHkVIIkhHAowDQYJKoZIhvcN
'' SIG '' AQEMBQAwVjELMAkGA1UEBhMCR0IxGDAWBgNVBAoTD1Nl
'' SIG '' Y3RpZ28gTGltaXRlZDEtMCsGA1UEAxMkU2VjdGlnbyBQ
'' SIG '' dWJsaWMgQ29kZSBTaWduaW5nIFJvb3QgUjQ2MB4XDTIx
'' SIG '' MDMyMjAwMDAwMFoXDTM2MDMyMTIzNTk1OVowVDELMAkG
'' SIG '' A1UEBhMCR0IxGDAWBgNVBAoTD1NlY3RpZ28gTGltaXRl
'' SIG '' ZDErMCkGA1UEAxMiU2VjdGlnbyBQdWJsaWMgQ29kZSBT
'' SIG '' aWduaW5nIENBIFIzNjCCAaIwDQYJKoZIhvcNAQEBBQAD
'' SIG '' ggGPADCCAYoCggGBAJsrnVP6NT+OYAZDasDP9X/2yFNT
'' SIG '' GMjO02x+/FgHlRd5ZTMLER4ARkZsQ3hAyAKwktlQqFZO
'' SIG '' GP/I+rLSJJmFeRno+DYDY1UOAWKA4xjMHY4qF2p9YZWh
'' SIG '' hbeFpPb09JNqFiTCYy/Rv/zedt4QJuIxeFI61tqb7/fo
'' SIG '' XT1/LW2wHyN79FXSYiTxcv+18Irpw+5gcTbXnDOsrSHV
'' SIG '' JYdPE9s+5iRF2Q/TlnCZGZOcA7n9qudjzeN43OE/TpKF
'' SIG '' 2dGq1mVXn37zK/4oiETkgsyqA5lgAQ0c1f1IkOb6rGnh
'' SIG '' WqkHcxX+HnfKXjVodTmmV52L2UIFsf0l4iQ0UgKJUc2R
'' SIG '' GarhOnG3B++OxR53LPys3J9AnL9o6zlviz5pzsgfrQH4
'' SIG '' lrtNUz4Qq/Va5MbBwuahTcWk4UxuY+PynPjgw9nV/35g
'' SIG '' RAhC3L81B3/bIaBb659+Vxn9kT2jUztrkmep/aLb+4xJ
'' SIG '' bKZHyvahAEx2XKHafkeKtjiMqcUf/2BG935A591Gsllv
'' SIG '' WwIDAQABo4IBZDCCAWAwHwYDVR0jBBgwFoAUMuuSmv81
'' SIG '' lkgvKEBCcCA2kVwXheYwHQYDVR0OBBYEFA8qyyCHKLjs
'' SIG '' b0iuK1SmKaoXpM0MMA4GA1UdDwEB/wQEAwIBhjASBgNV
'' SIG '' HRMBAf8ECDAGAQH/AgEAMBMGA1UdJQQMMAoGCCsGAQUF
'' SIG '' BwMDMBsGA1UdIAQUMBIwBgYEVR0gADAIBgZngQwBBAEw
'' SIG '' SwYDVR0fBEQwQjBAoD6gPIY6aHR0cDovL2NybC5zZWN0
'' SIG '' aWdvLmNvbS9TZWN0aWdvUHVibGljQ29kZVNpZ25pbmdS
'' SIG '' b290UjQ2LmNybDB7BggrBgEFBQcBAQRvMG0wRgYIKwYB
'' SIG '' BQUHMAKGOmh0dHA6Ly9jcnQuc2VjdGlnby5jb20vU2Vj
'' SIG '' dGlnb1B1YmxpY0NvZGVTaWduaW5nUm9vdFI0Ni5wN2Mw
'' SIG '' IwYIKwYBBQUHMAGGF2h0dHA6Ly9vY3NwLnNlY3RpZ28u
'' SIG '' Y29tMA0GCSqGSIb3DQEBDAUAA4ICAQAG/4Lhd2M2bnuh
'' SIG '' FSCbE/8E/ph1RGHDVpVx0ZE/haHrQECxyNbgcv2FymQ5
'' SIG '' PPmNS6Dah66dtgCjBsULYAor5wxxcgEPRl05pZOzI3IE
'' SIG '' Gwwsepp+8iGsLKaVpL3z5CmgELIqmk/Q5zFgR1TSGmxq
'' SIG '' oEEhk60FqONzDn7D8p4W89h8sX+V1imaUb693TGqWp3T
'' SIG '' 32IKGfIgy9jkd7GM7YCa2xulWfQ6E1xZtYNEX/ewGnp9
'' SIG '' ZeHPsNwwviJMBZL4xVd40uPWUnOJUoSiugaz0yWLODRt
'' SIG '' Qxs5qU6E58KKmfHwJotl5WZ7nIQuDT0mWjwEx7zSM7fs
'' SIG '' 9Tx6N+Q/3+49qTtUvAQsrEAxwmzOTJ6Jp6uWmHCgrHW4
'' SIG '' dHM3ITpvG5Ipy62KyqYovk5O6cC+040Si15KJpuQ9VJn
'' SIG '' bPvqYqfMB9nEKX/d2rd1Q3DiuDexMKCCQdJGpOqUsxLu
'' SIG '' COuFOoGbO7Uv3RjUpY39jkkp0a+yls6tN85fJe+Y8voT
'' SIG '' nbPU1knpy24wUFBkfenBa+pRFHwCBB1QtS+vGNRhsceP
'' SIG '' 3kSPNrrfN2sRzFYsNfrFaWz8YOdU254qNZQfd9O/VjxZ
'' SIG '' 2Gjr3xgANHtM3HxfzPYF6/pKK8EE4dj66qKKtm2DTL1K
'' SIG '' FCg/OYJyfrdLJq1q2/HXntgr2GVw+ZWhrWgMTn8v1SjZ
'' SIG '' sLlrgIfZHDCCBlkwggTBoAMCAQICEDxCloWJBEv5joxs
'' SIG '' ZT/3Id4wDQYJKoZIhvcNAQEMBQAwVDELMAkGA1UEBhMC
'' SIG '' R0IxGDAWBgNVBAoTD1NlY3RpZ28gTGltaXRlZDErMCkG
'' SIG '' A1UEAxMiU2VjdGlnbyBQdWJsaWMgQ29kZSBTaWduaW5n
'' SIG '' IENBIFIzNjAeFw0yMjA4MDUwMDAwMDBaFw0yNDA4MDQy
'' SIG '' MzU5NTlaMHAxCzAJBgNVBAYTAkpQMREwDwYDVQQIDAhL
'' SIG '' YW5hZ2F3YTEmMCQGA1UECgwdREFUQSBTQ0lFTkNFIENP
'' SIG '' TlNPUlRJVU0sIExURC4xJjAkBgNVBAMMHURBVEEgU0NJ
'' SIG '' RU5DRSBDT05TT1JUSVVNLCBMVEQuMIICIjANBgkqhkiG
'' SIG '' 9w0BAQEFAAOCAg8AMIICCgKCAgEAnJwI0e5e4+GgvtTS
'' SIG '' j6wSRBeQL5u7ofzQUfYJ2/7mwJ1Gzi+7/FdsXKYbczP0
'' SIG '' pg+zF3dq3LgHo8iSTfoNRlAU4uMiPbmdXIAURufiCeom
'' SIG '' 2hXBOvesLwjebm3kyfpU5GW52q7Ih9hgb7cmCOYn3FqO
'' SIG '' b2R1Mp4FvZLDE9do8/XFA1sJqGaleVq57MkrNEbFs2GM
'' SIG '' DRW9CtC2LZyhGqcxfF3/6/OVH2LEW4oUhJ1pSMsfCZIU
'' SIG '' 1x14aZVUBAcFOmBZBSUlUwwfrBKf8vk2rod50lhmH5jM
'' SIG '' gADAMpNITnay0lyswS1ynd6oSwaiuz1GpMQz4sff8gr+
'' SIG '' AVUsL5cbXw7JzbA5i42w5MbswWIHClKDG4uacZZU4DTU
'' SIG '' pVNrAw4fvnhlQCYDcJUgj5ulPbQhdLriDLstMuta6B6B
'' SIG '' gJWyyA1xxlns8Z3ah4hOEyjhk3QhNKbGrUpxj2s2KcZ8
'' SIG '' zK8ETkG05JEA+/de8lrN1lT2OmZobuZv1cXQ8N0jJet9
'' SIG '' tesgXXAHXC2y4oY5e+WbD8bek736pl0L+fMDQbSX/hP7
'' SIG '' Hxm1w3Vv6OSU50BLlwLmHepwt0mwzloB4HZv76oL9ShH
'' SIG '' o4K67Psrw48N0KsS7FakwIqSuO+6UNIHa2lTVIq0UhZM
'' SIG '' xtTVMPYW/d8rEbEmV2VD4geTONxP1ZabSW55E9Wg4zvh
'' SIG '' ch90mM0CAwEAAaOCAYkwggGFMB8GA1UdIwQYMBaAFA8q
'' SIG '' yyCHKLjsb0iuK1SmKaoXpM0MMB0GA1UdDgQWBBTCJID2
'' SIG '' CBLFz8JqKHdC6AjjU036HDAOBgNVHQ8BAf8EBAMCB4Aw
'' SIG '' DAYDVR0TAQH/BAIwADATBgNVHSUEDDAKBggrBgEFBQcD
'' SIG '' AzBKBgNVHSAEQzBBMDUGDCsGAQQBsjEBAgEDAjAlMCMG
'' SIG '' CCsGAQUFBwIBFhdodHRwczovL3NlY3RpZ28uY29tL0NQ
'' SIG '' UzAIBgZngQwBBAEwSQYDVR0fBEIwQDA+oDygOoY4aHR0
'' SIG '' cDovL2NybC5zZWN0aWdvLmNvbS9TZWN0aWdvUHVibGlj
'' SIG '' Q29kZVNpZ25pbmdDQVIzNi5jcmwweQYIKwYBBQUHAQEE
'' SIG '' bTBrMEQGCCsGAQUFBzAChjhodHRwOi8vY3J0LnNlY3Rp
'' SIG '' Z28uY29tL1NlY3RpZ29QdWJsaWNDb2RlU2lnbmluZ0NB
'' SIG '' UjM2LmNydDAjBggrBgEFBQcwAYYXaHR0cDovL29jc3Au
'' SIG '' c2VjdGlnby5jb20wDQYJKoZIhvcNAQEMBQADggGBAE1G
'' SIG '' X/7oVb/01A5wc2yPNtlkEuyeMWNKtnmusg1cTC7gj8TJ
'' SIG '' RfO6olJz0Hbo0rEy8uzUkjHvlIvzJkr2GXQ+pt3ZeSau
'' SIG '' 1wc5V7GQ7rtd+B2COiYDYSRcmmGbGGUI2xcWkZeVmw7c
'' SIG '' bU1YX0JWZV2iBVNV2yLf3w1CSrgyf6UawqX5KrUkczLf
'' SIG '' /b+N+4C+VtwSxCXTB4Y5JHfKE36ErFMygHGAagGQn2r+
'' SIG '' q2vLEufJw8JHvoyfztedIhN//0tZCtH137sHQYItJeLn
'' SIG '' alyqjk4cQIssdot37hWAciHdGY6O6d2APaIrPpgCVoCg
'' SIG '' liC1x+JYEunjFoo5mVfQta3h1HCVz6fPfvQhSqdVtHF7
'' SIG '' CNR5HHf+5eouEJGVoQsAeuipEds094vuhyik8blHVAvF
'' SIG '' 3S8i7YVDI2xAYDV+2/mbXufGClkf7bnw/vdLHSzTwC5D
'' SIG '' bce0VVqr2nd9BlEmMfgQ2dnjREbi/Dvg2PiOf7hF6lDZ
'' SIG '' CJvjmNs4nDiXPY6KyR6fftwIZzGCF+MwghffAgEBMGgw
'' SIG '' VDELMAkGA1UEBhMCR0IxGDAWBgNVBAoTD1NlY3RpZ28g
'' SIG '' TGltaXRlZDErMCkGA1UEAxMiU2VjdGlnbyBQdWJsaWMg
'' SIG '' Q29kZSBTaWduaW5nIENBIFIzNgIQPEKWhYkES/mOjGxl
'' SIG '' P/ch3jAJBgUrDgMCGgUAoHAwEAYKKwYBBAGCNwIBDDEC
'' SIG '' MAAwGQYJKoZIhvcNAQkDMQwGCisGAQQBgjcCAQQwHAYK
'' SIG '' KwYBBAGCNwIBCzEOMAwGCisGAQQBgjcCARUwIwYJKoZI
'' SIG '' hvcNAQkEMRYEFFXlyGk/jg6PYuk3gQGwT0yGVOwWMA0G
'' SIG '' CSqGSIb3DQEBAQUABIICACtW5jvvRl78oYGvZJ9k83Ot
'' SIG '' O2GSTj5aHyRiZDDvfM4MVxBtCX2qCjhyRyjK468cMlXE
'' SIG '' EPdcMRsiA6RVyntfvW/1JI6JRhtp22agqgIEv9CPBf8o
'' SIG '' 50Hc5EqNzsav+sYtJukzXXBRZJq6dQapOUjqRumC8onz
'' SIG '' NdroWyJSqbqTKPTeGbMxLr+TW0mzehWMh8M5z0x56XcS
'' SIG '' T1peXhW5ZpSExtXdmOdMgKWLypUj/iaiALMCMPAppzsN
'' SIG '' +dIbXFm3dpWod5gZ7TI5LruRldcZWqeZNHHl9IvaoDSq
'' SIG '' yxKD2oB28ZYCsnGOqf1cYksw0gTVBPvshq8691bcUDdM
'' SIG '' ezQBhc8/gVZTPSFdyvc3fmutbyU4tK0N69GCFQBHEy/B
'' SIG '' b/VgYB4NAqDCCYlbiQ1wO5gx77XUEQT+LdnD/xiCBQMb
'' SIG '' IoWfm4fQ9qsthsGpSQRBR4BKdzVXtYTPX4tgMrfTkoJW
'' SIG '' cwOl+JQh51iIn7PKhAAstnbT3QafxUhxBSwXjkhi8EYe
'' SIG '' En2J+GuZF2gl/bZDPWa75nYTU0nfMAcAyHk5cpMWFAbn
'' SIG '' qo4FvwiyVWF6voSLon8Iwd0ErMCnEPTbxGOuTQyAX0Qg
'' SIG '' dRNHQvgnUn1309rIuTapVR83WHYIoMFmnXkz4UYjv+pA
'' SIG '' O/Qk3f5kgGz0kI/G+ZcRyAM6MgXVDCieG3huAw/bD9Wh
'' SIG '' oYIU3jCCFNoGCisGAQQBgjcDAwExghTKMIIUxgYJKoZI
'' SIG '' hvcNAQcCoIIUtzCCFLMCAQMxDTALBglghkgBZQMEAgEw
'' SIG '' ZwYLKoZIhvcNAQkQAQSgWARWMFQCAQEGDCsGAQQBgqkw
'' SIG '' AQMGATAhMAkGBSsOAwIaBQAEFJCUe/hE8wa7V+Oacgmh
'' SIG '' zlA6i0/XAghMzqsqPgHd+hgPMjAyMzA4MjkwNjA3MzRa
'' SIG '' MAMCAQGgghHZMIIE+TCCAuGgAwIBAgIQGtYIp9Y0tc3e
'' SIG '' l8ujzPDQSzANBgkqhkiG9w0BAQsFADBzMQswCQYDVQQG
'' SIG '' EwJVUzEOMAwGA1UECAwFVGV4YXMxEDAOBgNVBAcMB0hv
'' SIG '' dXN0b24xETAPBgNVBAoMCFNTTCBDb3JwMS8wLQYDVQQD
'' SIG '' DCZTU0wuY29tIFRpbWVzdGFtcGluZyBJc3N1aW5nIFJT
'' SIG '' QSBDQSBSMTAeFw0yMjEyMDkxODMwNTFaFw0zMjEyMDYx
'' SIG '' ODMwNTBaMGsxCzAJBgNVBAYTAlVTMQ4wDAYDVQQIDAVU
'' SIG '' ZXhhczEQMA4GA1UEBwwHSG91c3RvbjERMA8GA1UECgwI
'' SIG '' U1NMIENvcnAxJzAlBgNVBAMMHlNTTC5jb20gVGltZXN0
'' SIG '' YW1waW5nIFVuaXQgMjAyMjBZMBMGByqGSM49AgEGCCqG
'' SIG '' SM49AwEHA0IABN58+pIllLLZNNnIXgaHKkSv1gJjjgpC
'' SIG '' v7j9Hb7hA4fIDEIvJgwiiVUtDNqo7JJ4jqcjiP/4vVoH
'' SIG '' cm/0d4E9O7ijggFaMIIBVjAfBgNVHSMEGDAWgBQMnRAl
'' SIG '' jpqnG5mHQ88IfuG9gZD0zzBRBggrBgEFBQcBAQRFMEMw
'' SIG '' QQYIKwYBBQUHMAKGNWh0dHA6Ly9jZXJ0LnNzbC5jb20v
'' SIG '' U1NMLmNvbS10aW1lU3RhbXBpbmctSS1SU0EtUjEuY2Vy
'' SIG '' MFEGA1UdIARKMEgwPAYMKwYBBAGCqTABAwYBMCwwKgYI
'' SIG '' KwYBBQUHAgEWHmh0dHBzOi8vd3d3LnNzbC5jb20vcmVw
'' SIG '' b3NpdG9yeTAIBgZngQwBBAIwFgYDVR0lAQH/BAwwCgYI
'' SIG '' KwYBBQUHAwgwRgYDVR0fBD8wPTA7oDmgN4Y1aHR0cDov
'' SIG '' L2NybHMuc3NsLmNvbS9TU0wuY29tLXRpbWVTdGFtcGlu
'' SIG '' Zy1JLVJTQS1SMS5jcmwwHQYDVR0OBBYEFAW6k9Hf4hSs
'' SIG '' ICqGWTF/KHIOraxfMA4GA1UdDwEB/wQEAwIHgDANBgkq
'' SIG '' hkiG9w0BAQsFAAOCAgEAWqi0lhBjDURozMeTk2UktonP
'' SIG '' EN/eeN5k1LeIys69k8AycnHM94hYaqd4jqvEZ07B7CpL
'' SIG '' eBhwI9koRqDZZVOOuEGkW03mgJ1udoJC5Zwke9/cfXTg
'' SIG '' 0GFiyqQKszBaijcTZR1rDj08F5mhkUzKQ+tpMb8jdbvo
'' SIG '' Wg/UG7Mj3GFIbnoPNGfeUjAiDzQmCKaxEBIkTBzDgrZS
'' SIG '' TRrVo7eEnz9EeFnsRnZtIRB/LKbrqRRu4aySzHNuC0JJ
'' SIG '' mmTvpct9P6tI4gvlJj5YIiJV34WtQ98uEUxLPGPBtW5E
'' SIG '' DkUt1wvv6n2S5KCClQj6bZ/PCuil1foYemnkR9h2lYZk
'' SIG '' N0H1H59sqIsLniBvN3a5sCsSfVAc7B7krWpeqNit6Vq0
'' SIG '' hs2UDk1RLsEmaZyOUu2IYx+rD9+ZJ8Y6+jWV7UcWdEWP
'' SIG '' VAlhf2tiS7aJO2MZLqOJQCY/pDbKK6efyc1W2BRgKisP
'' SIG '' k2yBuZUSrNxwgiQoiZb0jFYc5IUa7jVmzClIYoMAFx2r
'' SIG '' 41xRVPCODpCW8aLetC0BVkppdbNttlKJHuEzQIO1w/Bc
'' SIG '' 8p2Fu10aQma8K8F9ffnurv52aQHdcdgu16jER8KXMxEw
'' SIG '' n0AoXSpKHqF/g9OD1ZsvAU0IKVZB4z0Je2mLkRYPfC7k
'' SIG '' OV8gOkic3BRkM86tU7QMa736ax3vadow9dlOX5y+u/0w
'' SIG '' ggXYMIIEwKADAgECAhEA5CcElfaMkdbQ7HtJTqTfHDAN
'' SIG '' BgkqhkiG9w0BAQsFADB+MQswCQYDVQQGEwJQTDEiMCAG
'' SIG '' A1UEChMZVW5pemV0byBUZWNobm9sb2dpZXMgUy5BLjEn
'' SIG '' MCUGA1UECxMeQ2VydHVtIENlcnRpZmljYXRpb24gQXV0
'' SIG '' aG9yaXR5MSIwIAYDVQQDExlDZXJ0dW0gVHJ1c3RlZCBO
'' SIG '' ZXR3b3JrIENBMB4XDTE4MDkxMTA5MjY0N1oXDTIzMDkx
'' SIG '' MTA5MjY0N1owfDELMAkGA1UEBhMCVVMxDjAMBgNVBAgM
'' SIG '' BVRleGFzMRAwDgYDVQQHDAdIb3VzdG9uMRgwFgYDVQQK
'' SIG '' DA9TU0wgQ29ycG9yYXRpb24xMTAvBgNVBAMMKFNTTC5j
'' SIG '' b20gUm9vdCBDZXJ0aWZpY2F0aW9uIEF1dGhvcml0eSBS
'' SIG '' U0EwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAwggIKAoIC
'' SIG '' AQD5D92jK33L0Cr+7GeFpucuG7p34eP1r6Ts+kpdkcRX
'' SIG '' R2sYd2t28v2T5D0PwhaeC2bDVpSeF4OFzlbv8hb9AGL1
'' SIG '' IglU6GUXTkG54E9Gl6obyLhuYl5psV/bKgJ+/GzK80HY
'' SIG '' 7dDo/D9hSO2wAxQdEA5LGeC7TuyGZf82815nAgudhlVh
'' SIG '' /Xo47f7iGQC3b6FQYnV0PKD6yCWStG56Isf4HqHjst2R
'' SIG '' MasrHQT/pUoEN+mFpDMr/eLWVTR8GaRKaMeyqNO3yqGT
'' SIG '' iOvBl7yM+R3ZIoQkdMcEPWqpKZPM67hb4f5fJao0WMjB
'' SIG '' I1SdG5gRwzicfj2GbKUPQIZ8AvRcAk8oy65xnw86yDP+
'' SIG '' ESU16vy6xWA92XwY1bKp03V4A3IiyjrDH+8s5S6p+p4s
'' SIG '' tlFG/a8D1upgaOqFFjZrhekewLPdxCTcgCqBQW2UPsjg
'' SIG '' yYFBAJ5ev3/FCJiiGCxCQLP5bzgnS06A9D2BR+CIfOoc
'' SIG '' zrV1XFEuHCt/GnIo5wC10XTG1+SfrQeTtlM1Nfw35MP2
'' SIG '' XRa+IXPekgr4oGNqvJaSaj74vGVVm971DYkmBPwlGqYl
'' SIG '' acvCbcp84llfl6zr7y7IvNcbWTwrzPIZyJNrJ2MZz/zp
'' SIG '' JvjKcZt/k/40Z4ROmev8s3gJM3C6ZqZ27Rtz6xqlDcQi
'' SIG '' EyCUVgpOLGxOsf3PnAm6ojPthwIDAQABo4IBUTCCAU0w
'' SIG '' EgYDVR0TAQH/BAgwBgEB/wIBAjAdBgNVHQ4EFgQU3QQJ
'' SIG '' B6L1en1SUxKSle44gCUNplkwHwYDVR0jBBgwFoAUCHbN
'' SIG '' ywf/JPbFze27kLzihDdGdfcwDgYDVR0PAQH/BAQDAgEG
'' SIG '' MDYGA1UdHwQvMC0wK6ApoCeGJWh0dHA6Ly9zc2xjb20u
'' SIG '' Y3JsLmNlcnR1bS5wbC9jdG5jYS5jcmwwcwYIKwYBBQUH
'' SIG '' AQEEZzBlMCkGCCsGAQUFBzABhh1odHRwOi8vc3NsY29t
'' SIG '' Lm9jc3AtY2VydHVtLmNvbTA4BggrBgEFBQcwAoYsaHR0
'' SIG '' cDovL3NzbGNvbS5yZXBvc2l0b3J5LmNlcnR1bS5wbC9j
'' SIG '' dG5jYS5jZXIwOgYDVR0gBDMwMTAvBgRVHSAAMCcwJQYI
'' SIG '' KwYBBQUHAgEWGWh0dHBzOi8vd3d3LmNlcnR1bS5wbC9D
'' SIG '' UFMwDQYJKoZIhvcNAQELBQADggEBAB+VmiNU7oXC89Rv
'' SIG '' uekEj0Z/LPcywKdDrAcA7eCpRS39F+HtAEDIr5is9cAZ
'' SIG '' rRuglzBAbOxb+6OTToyJYht88Dpfp0LPWMp1ZZwiTL92
'' SIG '' e5iTnBWDM7EO3FE4h3yVnBJplB4AeHR+3MAGd7pwLYcs
'' SIG '' 12id47qFrUnzj2S0FQaDksaXpECTi63xZ5S0uVpnVDyo
'' SIG '' G9kFz+Sk+YgSAAaIJYXUXu7zk1fWgfgsrvf1UUirtmI6
'' SIG '' edvsLvI/FFY6yNnLpKJPJajRm6stMCBQBxpv8fGUHTmD
'' SIG '' Y+gf/UnQ6B1GskaCJr2cneGiaEFIUW56/DWW9FTSvCtE
'' SIG '' 5UfXd4KlSqtflzOrJBEwggb8MIIE5KADAgECAhBtUhhw
'' SIG '' h+gjTYVgANCAj5NWMA0GCSqGSIb3DQEBCwUAMHwxCzAJ
'' SIG '' BgNVBAYTAlVTMQ4wDAYDVQQIDAVUZXhhczEQMA4GA1UE
'' SIG '' BwwHSG91c3RvbjEYMBYGA1UECgwPU1NMIENvcnBvcmF0
'' SIG '' aW9uMTEwLwYDVQQDDChTU0wuY29tIFJvb3QgQ2VydGlm
'' SIG '' aWNhdGlvbiBBdXRob3JpdHkgUlNBMB4XDTE5MTExMzE4
'' SIG '' NTAwNVoXDTM0MTExMjE4NTAwNVowczELMAkGA1UEBhMC
'' SIG '' VVMxDjAMBgNVBAgMBVRleGFzMRAwDgYDVQQHDAdIb3Vz
'' SIG '' dG9uMREwDwYDVQQKDAhTU0wgQ29ycDEvMC0GA1UEAwwm
'' SIG '' U1NMLmNvbSBUaW1lc3RhbXBpbmcgSXNzdWluZyBSU0Eg
'' SIG '' Q0EgUjEwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAwggIK
'' SIG '' AoICAQCuURAT0vk8IKAghd7JUBxkyeH9xek0/wp/MUjo
'' SIG '' clrFXqhh/fGH91Fc+7fm0MHCE7A+wmOiqBj9ODrJAYGq
'' SIG '' 3rm33jCnHSsCBNWAQYyoauLq8IjqsS1JlXL29qDNMMdw
'' SIG '' Z8UNzQS7vWZMDJ40JSGNphMGTIA2qn2bohGtgRc4p139
'' SIG '' 5ESypUOaGvJ3t0FNL3BuKmb6YctMcQUF2sqooMzd89h0
'' SIG '' E6ujdvBDo6ZwNnWoxj7YmfWjSXg33A5GuY9ym4QZM5OE
'' SIG '' Vgo8ebz/B+gyhyCLNNhh4Mb/4xvCTCMVmNYrBviGgdPZ
'' SIG '' Yrym8Zb84TQCmSuX0JlLLa6WK1aO6qlwISbb9bVGh866
'' SIG '' ekKblC/XRP20gAu1CjvcYciUgNTrGFg8f8AJgQPOCc1/
'' SIG '' CCdaJSYwhJpSdheKOnQgESgNmYZPhFOC6IKaMAUXk5U1
'' SIG '' tjTcFCgFvvArXtK4azAWUOO1Y3fdldIBL6LjkzLUCYJN
'' SIG '' kFXqhsBVcPMuB0nUDWvLJfPimstjJ8lF4S6ECxWnlWi7
'' SIG '' OElVwTnt1GtRqeY9ydvvGLntU+FecK7DbqHDUd366Ure
'' SIG '' MkSBtzevAc9aqoZPnjVMjvFqV1pYOjzmTiVHZtAc80bA
'' SIG '' fFe5LLfJzPI6DntNyqobpwTevQpHqPDN9qqNO83r3kaw
'' SIG '' 8A9j+HZiSw2AX5cGdQP0kG0vhzfgBwIDAQABo4IBgTCC
'' SIG '' AX0wEgYDVR0TAQH/BAgwBgEB/wIBADAfBgNVHSMEGDAW
'' SIG '' gBTdBAkHovV6fVJTEpKV7jiAJQ2mWTCBgwYIKwYBBQUH
'' SIG '' AQEEdzB1MFEGCCsGAQUFBzAChkVodHRwOi8vd3d3LnNz
'' SIG '' bC5jb20vcmVwb3NpdG9yeS9TU0xjb21Sb290Q2VydGlm
'' SIG '' aWNhdGlvbkF1dGhvcml0eVJTQS5jcnQwIAYIKwYBBQUH
'' SIG '' MAGGFGh0dHA6Ly9vY3Nwcy5zc2wuY29tMD8GA1UdIAQ4
'' SIG '' MDYwNAYEVR0gADAsMCoGCCsGAQUFBwIBFh5odHRwczov
'' SIG '' L3d3dy5zc2wuY29tL3JlcG9zaXRvcnkwEwYDVR0lBAww
'' SIG '' CgYIKwYBBQUHAwgwOwYDVR0fBDQwMjAwoC6gLIYqaHR0
'' SIG '' cDovL2NybHMuc3NsLmNvbS9zc2wuY29tLXJzYS1Sb290
'' SIG '' Q0EuY3JsMB0GA1UdDgQWBBQMnRAljpqnG5mHQ88IfuG9
'' SIG '' gZD0zzAOBgNVHQ8BAf8EBAMCAYYwDQYJKoZIhvcNAQEL
'' SIG '' BQADggIBAJIZdQ2mWkLPGQfZ8vyU+sCb8BXpRJZaL3Ez
'' SIG '' 3VDlE3uZk3cPxPtybVfLuqaci0W6SB22JTMttCiQMnIV
'' SIG '' OsXWnIuAbD/aFTcUkTLBI3xys+wEajzXaXJYWACDS47B
'' SIG '' RjDtYlDW14gLJxf8W6DQoH3jHDGGy8kGJFOlDKG7/YrK
'' SIG '' 7UGfHtBAEDVe6lyZ+FtCsrk7dD/IiL/+Q3Q6SFASJLQ2
'' SIG '' XI89ihFugdYL77CiDNXrI2MFspQGswXEAGpHuaQDTHUp
'' SIG '' /LdR3TyrIsLlnzoLskUGswF/KF8+kpWUiKJNC4rPWtNr
'' SIG '' xlbXYRGgdEdx8SMjUTDClldcrknlFxbqHsVmr9xkT2Qt
'' SIG '' FmG+dEq1v5fsIK0vHaHrWjMMmaJ9i+4qGJSD0stYfQ6v
'' SIG '' 0PddT7EpGxGd867Ada6FZyHwbuQSadMb0K0P0OC2r7rw
'' SIG '' qBUe0BaMqTa6LWzWItgBjGcObXeMxmbQqlEz2YtAcErk
'' SIG '' Zvh0WABDDE4U8GyV/32FdaAvJgTfe9MiL2nSBioYe/g5
'' SIG '' mHUSWAay/Ip1RQmQCvmF9sNfqlhJwkjy/1U1ibUkTIUB
'' SIG '' X3HgymyQvqQTZLLys6pL2tCdWcjI9YuLw30rgZm8+K38
'' SIG '' 7L7ycUvqrmQ3ZJlujHl3r1hgV76s3WwMPgKk1bAEFMj+
'' SIG '' rRXimSC+Ev30hXZdqyMdl/il5Ksd0vhGMYICVzCCAlMC
'' SIG '' AQEwgYcwczELMAkGA1UEBhMCVVMxDjAMBgNVBAgMBVRl
'' SIG '' eGFzMRAwDgYDVQQHDAdIb3VzdG9uMREwDwYDVQQKDAhT
'' SIG '' U0wgQ29ycDEvMC0GA1UEAwwmU1NMLmNvbSBUaW1lc3Rh
'' SIG '' bXBpbmcgSXNzdWluZyBSU0EgQ0EgUjECEBrWCKfWNLXN
'' SIG '' 3pfLo8zw0EswCwYJYIZIAWUDBAIBoIIBYTAaBgkqhkiG
'' SIG '' 9w0BCQMxDQYLKoZIhvcNAQkQAQQwHAYJKoZIhvcNAQkF
'' SIG '' MQ8XDTIzMDgyOTA2MDczNFowKAYJKoZIhvcNAQk0MRsw
'' SIG '' GTALBglghkgBZQMEAgGhCgYIKoZIzj0EAwIwLwYJKoZI
'' SIG '' hvcNAQkEMSIEIDyKLFkZzrbBNS/36nFgUWZcsobhUx1S
'' SIG '' mF9Ua4emgoTYMIHJBgsqhkiG9w0BCRACLzGBuTCBtjCB
'' SIG '' szCBsAQgjcXEJULSTxXP9cgZbtRag2jUyta9y+Qhqd4j
'' SIG '' UJ2L0yIwgYswd6R1MHMxCzAJBgNVBAYTAlVTMQ4wDAYD
'' SIG '' VQQIDAVUZXhhczEQMA4GA1UEBwwHSG91c3RvbjERMA8G
'' SIG '' A1UECgwIU1NMIENvcnAxLzAtBgNVBAMMJlNTTC5jb20g
'' SIG '' VGltZXN0YW1waW5nIElzc3VpbmcgUlNBIENBIFIxAhAa
'' SIG '' 1gin1jS1zd6Xy6PM8NBLMAoGCCqGSM49BAMCBEYwRAIg
'' SIG '' ARpqFJ4qhUMxIeTW4U5oRlTpCzwKH/28o7s80UxVM1wC
'' SIG '' IDCnmJTd1DtY7ONhj3+BihLomNd+JwruBzoMysfE3kf3
'' SIG '' End signature block
